<template>
	<view class="translation">
		<!-- 暂时注释，暂缓使用 -->
		<!-- 	<view style="width: 690rpx;height: 64rpx;margin: 0 auto;margin-top: 30rpx;background: #F2F2F2;border-radius: 32rpx;
		display: flex;align-items: center;" @tap="toKeywordsearch()">
			<image style="width: 28rpx;height: 28rpx;margin-left: 30rpx;" src="/static/images/search.png" mode=""></image>
			<text style="margin-left: 10rpx;color: #999999;font-size: 24rpx;">请输入关键字</text>
		</view> -->
		<view class="top" style="margin-top: 30rpx;">
			<view class="title">
				<view class="call_record_time">{{date}}</view>
			</view>
			<view class="call_record_time_one">接待时长 {{alltimeStr}}
				<image src="/static/images/menu.png" @click="showFile" class="menu" mode="" />
				<view class="audoioyouxiao" @click="alllogo()" v-if="permissions.commonly2">
					{{userlistobj.validInvalidName||''}}
				</view>
				<view class="file-change" v-if="isshowFile">
					<view class="file-item" @click="filechange(item, index)"
						:class="csdFileindex == index ? 'fileactive' : ''" v-for="(item,index) in luyinList"
						:key="index">录音文件{{index+1}}</view>
				</view>
				<view class="diangweitupian" v-if="jiaoseshow">
					<image v-if="status==1" @click="tappick()" style="width: 100%;height: 100%;"
						src="../../static/images/pike.png" mode=""></image>
					<image v-if="status==0" @click="notappick()" style="width: 100%;height: 100%;"
						src="../../static/images/nopike.png" mode=""></image>
				</view>
			</view>
			<zaudio @checkPlaybackRate="checkPlaybackRate" theme="theme4"></zaudio>
		</view>
		<scroll-view :scroll-top="scrollTop" lower-threshold='20px' @scrolltolower="ltolower()"
			:scroll-into-view="scrollId" scroll-y="true" class="text scroll-Y">
			<!-- tab 栏切换 -->
			<view class="tab-box" id="top">
				<view class="yinpinshibie" @click="changeTab(0)" :class="{active: tab==0}">
					音频识别
				</view>
				<view class="rate" @click="changeTab(1)" :class="{active: tab==1}">
					评分
				</view>
			</view>
			<!-- 音频识别模块 -->
			<view v-if="tab==0">
				<!-- 聊天记录-->
				<view class="dialog-block" v-for="(dialog,i) in dialogList" :key="i">
					<view :id="'dialog'+i" class="fileName">录音文件
						<!-- {{i+1}} -->
					</view>
					<view class="text" :id="'dialog'+csdFileindex+'text'+item.bg"
						:class="{active: Math.floor(item.bg/1000) <= playNow && Math.floor(item.ed/1000) > playNow && i==0}"
						v-for="(item,index) in dialog.message" :key="index" :data-speaker="item.speaker">
						<view class="avatar">
							<text :style="[borderColor(item.speaker)]">{{ item.speaker | toCapital }}</text>
						</view>
						<view class="content">
							<view class="contentdesc" @longpress="changanxiaoguo(item,index,i)" v-html="item.onebest">
							</view>

							<image v-if="Math.floor(item.bg/1000) <= playNow && Math.floor(item.ed/1000) > playNow"
								class="play" src="https://static.quhouse.com/ce73a5225f7f44be9f313b0e4e4c2c0e.png">
							</image>
							<image v-else @click="clickbofang(dialog.backindex,item)" class="play"
								src="https://static.quhouse.com/1b6ac53247e043a1bdc59ecfb2167eba.png"></image>

							<template v-if="item.isshow">
								<view class="tankuangcss">
									<view class="tankuangcss-items" @click="clickcopy()">
										<image src="@/static/images/detail/icon1.png" mode=""></image>
										<text>复制</text>
									</view>
									<view class="tankuangcss-items" @click="Oftenthewrongword()"
										v-if="permissions.commonly4">
										<image src="@/static/images/detail/icon2.png" mode=""></image>
										<text>常错词</text>
									</view>
									<view class="tankuangcss-items" @click="Addtheessence()"
										v-if="permissions.commonly3">
										<image src="@/static/images/detail/icon3.png" mode=""></image>
										<text>加精华</text>
									</view>
									<!-- 									<view class="tankuangcss-items" @click="clickbofang(dialog.backindex,item)">
										<image src="@/static/images/detail/icon4.png" mode=""></image>
										<text>播放</text>
									</view> -->
								</view>
							</template>
						</view>
					</view>
				</view>
			</view>
			<!-- 评分模块 -->
			<view v-if="tab==1" class="rate-box">
				<view class="title">总执行率 {{totalRate}}%</view>
				<view v-for="(item,index) in ratelist" :key="index" class="u-m-b-14">
					<view class="level1">
						<view class="level-name u-line-1">
							{{item.name}}
						</view>
						<view class="level-progress">
							<view class="color" :style="{width: item.ratepercent/item.rate*100+'%'}"></view>
						</view>
						<view class="level-rate">{{((item.ratepercent/item.rate).toFixed(2)*100).toFixed()}}%</view>
						<image v-if="!item.show" class="arrow rotatearrow" @click="changeshow(item,1)"
							src="/static/images/down.png" mode="" />
						<image v-else class="arrow" @click="changeshow(item,0)" src="/static/images/up.png" mode="" />
					</view>
					<view class="level1-subbox" v-if="item.show">
						<view class="sub-name" v-for="(subitem,i) in item.children" :key="i">
							<view class="subitem-name u-line-1">{{subitem.name}}</view>
							<image class="checkimg" v-if="!subitem.selected" src="/static/images/rate-checked.png"
								mode="" />
							<image class="checkimg" v-else src="/static/images/rate-nocheck.png" mode="" />
						</view>
					</view>
				</view>
			</view>
		</scroll-view>

		<!-- 回到顶部 -->
		<view class="backTop" @click="gotoTop">
			<image src="/static/images/topicon.png" mode=""></image>
		</view>

		<template v-if="permissions.sbrz">
			<view class="eqLog" @click="eqLogClick">
				<view style="width: 78rpx;text-align: center;">设备日志</view>
			</view>
		</template>

		<!-- 加入常错词 -->
		<view class="zhezhoa" v-if="isshow2" @tap="Cancelout"></view>

		<u-modal v-model="isshow2" title="添加常错词" :show-cancel-button="true" @cancel="Cancelout"
			@confirm="Confirmtheexit">
			<view class="tian-view">
				<viwe class="tian-view-t1"></viwe>
				<viwe class="tian-view-t2">常错词：</viwe>
				<viwe class="tian-view-t3">
					<u-input :auto-height="false" type="textarea" v-model="thewrongword" :disabled="isNum"
						:custom-style="customStyle" placeholder="请输入" />
				</viwe>
			</view>
			<view class="tian-view" style="margin-bottom: 74rpx;">
				<viwe class="tian-view-t1"></viwe>
				<viwe class="tian-view-t2">正确词：</viwe>
				<viwe class="tian-view-t3">
					<u-input :auto-height="false" :custom-style="customStyle" v-model="reswrongword" type="textarea" placeholder="请输入" />
				</viwe>
			</view>
		</u-modal>
		<!-- 加精华 -->
		<view class="zhezhoa" v-if="isshow3" @tap="Cancelout2"></view>
		<view class="bounced" v-if="isshow3">
			<view class="jiajinghuatit">加精华</view>
			<view style="width: 100%;text-indent: 20rpx;font-size: 28rpx;">选择标签</view>
			<view class="jiajinghuaview">
				<view class="jighuaview2" v-for="(item,index) in biaoqianlist" :key="index"
					:class="biaoqianindex == index ? 'biaoqiantom' : ''">
					<view class="view1-text" @click="tapbiaoqianclisck(index)">{{item.name}}</view>
				</view>
			</view>
			<view class="bounced3">
				<view class="bounced3-1" @tap="Cancelout2">取消</view>
				<view class="bounced3-2" @tap="Confirmtheexit2">确认</view>
			</view>
		</view>

		<view class="zhezhoa" v-if="effective"></view>
		<view class="bounced" v-if="effective">
			<view class="jiajinghuatit">选择</view>
			<view>
				<view class="uni-list">
					<radio-group @change="radioChange">
						<label style="display: flex;align-items: center;font-size: 30rpx;
					width: 94%;height: 80rpx;margin: 0 auto;" v-for="(item, index) in effectiveitems" :key="item.value">
							<view style="margin-top: 2rpx;flex: 1; text-indent: 20rpx;">{{item.name}}</view>
							<view style="width: 80rpx;">
								<radio :value="item.value" :checked="index == effectiveindex" />
							</view>
						</label>
					</radio-group>
				</view>
				<view v-if="effectiveindex==4">
					<u-input class="ffectivetext" v-model="effectiveitext" placeholder="备注" />
				</view>
			</view>
			<view class="bounced3">
				<view class="bounced3-1" @click="effective=false">取消</view>
				<view class="bounced3-2" @click="$noMultipleClicks(effectiveAdd)">确认</view>
			</view>
		</view>

		<u-toast ref="uToast" />
	</view>
</template>

<script>
	var util = require("../../utils/util.js");
	var config = require("../../config");
	import zaudio from '@/components/uniapp-zaudio/zaudio';
	export default {
		components: {
			zaudio
		},
		data() {
			return {
				customStyle: {
					'width': '320rpx',
					'font-size': '34rpx',
					'height': '30rpx',
					'border-bottom': '1px solid #ccc'
				},
				noClick: true,
				recordPath: "",
				customerId: "",
				luyinList: [], //录音文件
				dialogList: [], //录音识别列表
				csdFileindex: 0,
				isshowFile: false, //录音列表隐藏
				date: "", //年月日
				tab: 0, // 默认是音频识别
				scrollTop: 0,
				scrollId: "",
				playNow: 0,
				alltimeStr: "00:00:00",
				ratelist: [], //评分列表
				totalRate: "",
				thewrongword: "", //错误词
				reswrongword: "", //正确词
				isshow2: false,
				messagelisy: [],
				isshow3: false,
				biaoqianlist: [],
				biaoqianindex: 0,
				changanitem: {},
				duihuawenjianid: "",
				biaoqianid: "",
				status: 0,
				num: 0, //上拉  转写文件下标
				Bnum: 0, //下拉  转写文件下标
				itemobj: {},
				buildingID: '',
				userlistobj: {},

				effective: false,
				effectiveindex: '0',
				effectiveitems: [{
						value: '1',
						name: '没电指派无录音',
						checked: true
					},
					{
						value: '2',
						name: '离线指派无录音',
					},
					{
						value: '3',
						name: '系统测试误操作'
					},
					{
						value: '4',
						name: '非接访场景录音'
					},
					{
						value: '5',
						name: '其他'
					}
				],
				effectiveitext: '',
				textItself: '',
				argtextindex1: 0,
				argtextindex2: 0,
				permissions: {
					commonly2: false,
					commonly3: false,
					commonly4: false,
				},

				ACTION: Symbol('zaudios'), // 唯一值区分每个页面的方法
				isPageHide: false, // 是否息屏
				isNum: false,
				
				nowPlaying: 0, // 当前播放位置
				stepPosition: 0, // 需要跳转的播放位置
			};
		},


		onLoad(options) {
			this.status = options.status;
			this.customerId = options.customerId;
			this.itemobj = uni.getStorageSync('searchobj');
			this.stateisshow = options.stateisshow;

			this.addLookingCount(options.customerId)
			this.$zaudio.autoPlay = true

			//注意: 不同的回调方法, 相同的业务函数方法名, 不会相互影响;
			this.$zaudio.on('stop', this.ACTION, () => {
				console.log('我是强制暂停或关闭小程序音频浮窗触发的')
			})
			this.$zaudio.on('seek', this.ACTION, (time) => {
				this.sliderChangeComplate(this.TIMEEVENT(time))
			})
			this.$zaudio.on('playing', this.ACTION, (obj) => {
				this.nowPlaying = obj.current_value
				this.TimeUpdate(this.TIMEEVENT(obj.current))
			})
			this.$zaudio.on('ended', this.ACTION, e => {
				this.$nextTick(() => {
					this.scrollId = "";
				})
				this.qeihuanwenjian()
			})
			this.$zaudio.on('error', this.ACTION, e => {

			})
			uni.$on('DETAILSINIT', info => {
				this.init(info)
			})
		},
		onShow() {
			//实时渲染当前的播放状态
			this.$zaudio.syncRender()
			let newmenulist = uni.getStorageSync('weapp_session_Menu_data');
			this.permissions.commonly2 = newmenulist.jdwxbj; //1 接待无效标记 jdwxbj
			this.permissions.commonly3 = newmenulist.swyxal; //1 设为优秀案例 swyxal
			this.permissions.commonly4 = newmenulist.ccc; // 常错词 ccc
			this.permissions = {
				...newmenulist,
				...this.permissions
			}
			this.buildingID = uni.getStorageSync('buildingID').id;
			if (this.stateisshow == 2) {
				var info = this.itemobj
			}
			this.gituserlist();
			!this.isPageHide && this.init(info)
		},

		onHide() {
			this.isPageHide = true
		},

		onUnload() {
			//卸载不需要的业务和获取播放状态的业务,提高页面性能
			this.$zaudio.off('seek', this.ACTION);
			this.$zaudio.off('stop', this.ACTION);
			this.$zaudio.off('playing', this.ACTION);
			this.$zaudio.off('ended', this.ACTION);
			this.$zaudio.off('error', this.ACTION);
		},


		methods: {
			borderColor(index) {
				let obj = {
					color: '',
					borderRadius: '',
					border: ''
				}
				switch (index) {
					case 1:
						obj.color = '#E6625B';
						obj.borderRadius = '8rpx';
						obj.border = '2rpx solid #E6625B';
						break;
					case 2:
						obj.color = '#FF981E';
						obj.borderRadius = '8rpx';
						obj.border = '2rpx solid #FF981E';
						break;
					case 3:
						obj.color = '#F6BD16';
						obj.borderRadius = '8rpx';
						obj.border = '2rpx solid #F6BD16';
						break;
					case 5:
						obj.color = '#4980C8';
						obj.borderRadius = '8rpx';
						obj.border = '2rpx solid #4980C8';
						break;
					case 6:
						obj.color = '#60CBEC';
						obj.borderRadius = '8rpx';
						obj.border = '2rpx solid #60CBEC';
						break;
					case 7:
						obj.color = '##FF981E';
						obj.borderRadius = '8rpx';
						obj.border = '2rpx solid #FF981E';
						break;
					case 8:
						obj.color = '#4F861E';
						obj.borderRadius = '8rpx';
						obj.border = '2rpx solid #4F861E';
						break;
					default:
						obj.color = '#9F61C8';
						obj.borderRadius = '8rpx';
						obj.border = '2rpx solid #9F61C8';
						break;
				}
				return obj
			},
			effectiveAdd() {
				if (this.effectiveindex == 4) {
					if (this.effectiveitext.length == 0) {
						uni.showToast({
							title: '备注不能为空',
							icon: "none",
							duration: 2000
						});
						return
					}
				}
				this.effective = false;
				let parames = {
					id: this.customerId,
					validInvalid: '',
					validInvalid: 1,
					invalidReason: Number(this.effectiveindex) + 1,
					invalidNote: this.effectiveitext
				}
				this.$u.post("/customer/updateValidInvalid", parames).then(res => {
					console.log(res)
					this.gituserlist()
				})
			},
			radioChange(evt) {
				this.effectiveitext = "";
				for (let i = 0; i < this.effectiveitems.length; i++) {
					if (this.effectiveitems[i].value === evt.detail.value) {
						this.effectiveindex = i;
						break;
					}
				}
			},
			//标记
			alllogo() {
				let msg = '';
				var that = this;
				if (this.userlistobj.validInvalid != 0) {
					msg = '是否标记为"有效录音"？';
					uni.showModal({
						title: '提示',
						content: msg,
						success: (res) => {
							if (that.noClick) {
								that.noClick = false;
								if (res.confirm) {
									let parames = {
										id: this.customerId,
										validInvalid: '',
										invalidReason: 0
									}
									if (this.userlistobj.validInvalid == 0) {
										parames.validInvalid = 1;
									} else {
										parames.validInvalid = 0;
									}
									this.$u.post("/customer/updateValidInvalid", parames).then(res => {
										console.log(res)
										this.gituserlist()
									})
								}
								setTimeout(() => {
									that.noClick = true;
								}, 2000)

							}
						}
					});
				} else {
					this.effective = true;
				}
			},

			//获取用户信息
			gituserlist() {
				this.$u.get("/matchKeywords/personalReceptionRecord", {
					customerId: this.customerId
				}).then(res => {
					try {
						res.endTime1 = res.endTime.substring(0, 19);
						this.userlistobj = res;
					} catch (e) {
						console.log(e)
					}
				})
			},
			toKeywordsearch() {
				this.stateisshow = 1;
				uni.navigateTo({
					url: '/pages/learning/Keywordsearch?customerId=' + this.customerId + "&status=" + this.status +
						"&skpl=" + "1" + '$UpDateEvent=DETAILSINIT'
				})
			},



			TimeUpdate(currentTime) {
				this.playNow = Number(currentTime)
				if (this.dialogList.length == 0) {
					return
				} else {
					const message = this.dialogList[0].message;
					if (!message) return
					for (let i = 0; i < message.length; i++) {
						if ((Math.floor(message[i].bg / 1000) <= this.playNow && this.playNow < Math.floor(message[i].ed /
								1000))) {
							console.log(message[i])
							this.scrollId = "dialog" + this.csdFileindex + "text" + message[i].bg;
							break;
						}
						if (i < message.length - 1 && Math.floor(message[i].ed / 1000) < this.playNow && this.playNow <
							Math.floor(message[i + 1].bg / 1000)) {
							this.scrollId = "dialog" + this.csdFileindex + "text" + message[i].bg;
							break;
						}
					}
				}
				this.$forceUpdate()
			},

			init(info) {
				const parames = {
					pageNum: 1,
					pageSize: 100,
					query: {
						customerId: this.customerId
					}
				}
				this.$u.post("/corpus/findByPage", parames).then(res => {
					if (res && res.length) {
						let alltime = 1;
						res.forEach(item => {
							item.recordDuration = item.recordDuration / 1
							alltime += item.recordDuration
						})
						this.recordDuration = this.getTime(res[0].recordDuration)
						this.alltimeStr = this.getTime(alltime)
						if (info) {
							res.forEach((item, index) => {
								// console.log(item, '打印音频列表内容')
								if (item.id == info.id) {
									this.luyinList = res;
									this.csdFileindex = index;
									this.recordPath = res[index].recordPath
									this.date = res[index].receptionTime;
									this.isshowFile = false;
									this.getCorpusAnalysis(info);
									var itc = info.bg / 1000
									this.adasdasdasd(itc)
								}
							})
						} else {
							this.recordPath = res[0].recordPath
							this.date = res[0].receptionTime
							this.luyinList = res;
							this.getCorpusAnalysis()
						}
						this.zyAudio()
					}
				})
			},

			//搜索跳转
			adasdasdasd(e) {
				this.stepPlay(e)
			},
			//下一页
			ltolower() {
				var lengthcz = this.luyinList.length - 1;
				if (this.num >= lengthcz) {
					uni.showToast({
						title: '到底了',
						icon: 'none',
						duration: 2000
					});
					return
				} else {
					this.num = this.num + 1;
					let obj = {
						corpusId: this.luyinList[this.num].id,
						customerId: this.customerId,
					}
					this.$u.get(config.service.getCorpusAnalysis, obj).then(data => {
						console.log(data)
						if (!data.audioContent) {
							setTimeout(function() {}, 2000);
						} else {
							const jsonInfo = JSON.parse(data.audioContent);
							this.dialogList.push({
								message: jsonInfo,
								backindex: this.num
							});
							this.dialogList.forEach((asd, idx) => {
								asd.message.forEach((qwe, inde) => {
									qwe.isshow = false;
								})
							})
						}
						uni.hideLoading();
					}).catch(e => {
						uni.hideLoading();
					})
				}
			},

			// 取消全部加精
			notappick() {
				uni.showModal({
					title: '提示',
					content: '确认取消加精？',
					success: (res) => {
						if (res.confirm) {
							let params = {
								carId: this.customerId,
							}
							this.$u.get(config.service.delATD, params).then(data => {
								console.log(data)
								this.status = 1
								uni.showToast({
									title: data.message,
									duration: 2000
								});
							})
						} else if (res.cancel) {
							console.log('用户点击取消');
						}
					}
				});
			},
			//全部加精
			tappick(i) {
				uni.showModal({
					title: '提示',
					content: '确认加精？',
					success: (res) => {
						if (res.confirm) {
							let objdata = {
								"carId": that.customerId, //客户id
								"status": 0,
								"itemId": that.buildingID,
							}
							this.$u.post(config.service.addATD, objdata).then(data => {
								this.status = 0
								uni.showToast({
									title: data.message,
									duration: 2000
								});
							})
						} else if (res.cancel) {
							console.log('用户点击取消');
						}
					}
				});
			},
			//标签选择
			tapbiaoqianclisck(index) {
				this.biaoqianindex = index;
				this.biaoqianid = this.biaoqianlist[index].id
			},
			//复制
			clickcopy() {
				var that = this;
				uni.setClipboardData({
					data: that.thewrongword,
					success: function() {
						that.dialogList.forEach(res => {
							res.message.forEach(asd => {
								asd.isshow = false;
							})
						})
						that.$forceUpdate();
					}
				});
			},
			//确认加入常错词
			Confirmtheexit() {
				if (this.reswrongword.length > 8 || this.thewrongword.length > 8) {
					this.$refs.uToast.show({
						title: '正确词错误词不能超过8个字',
						type: 'warning',
					})
				} else {
					let reg = /^[0-9]+$/
					if (reg.test(this.thewrongword)) {
						this.$refs.uToast.show({
							title: '错误词不能为纯数字',
							type: 'warning',
						})
					} else {
						if (this.thewrongword) {
							if (this.reswrongword) {
								let parames = {
									customerId: this.customerId,
									cupid: this.luyinList[this.csdFileindex].id,
									wrongWord: this.thewrongword, //错误词
									correctWord: this.reswrongword, //正确词
									translateHtmlContent: this.messagelisy,

								}
								this.isshow2 = false;
								let sas = this.textItself.replace(this.thewrongword, this.reswrongword)
								this.dialogList[this.argtextindex1].message[this.argtextindex2].onebest = sas
								this.dialogList.forEach(res => {
									res.message.forEach(asd => {
										asd.isshow = false;
									})
								})
								this.$u.post("/corpus/addCorrectWord", parames).then(data => {
									this.thewrongword = "";
									this.reswrongword = "";
								})
							} else {
								uni.showToast({
									title: '正确值不能为空',
									duration: 2000
								});
								return
							}
						} else {
							uni.showToast({
								title: '错误词不能为空',
								duration: 2000
							});
							return
						}
					}
				}

			},
			//取消加入常错词
			Cancelout() {
				this.isshow2 = false;
				this.dialogList.forEach(res => {
					res.message.forEach(asd => {
						asd.isshow = false;
					})
				})
			},
			//加入长错词
			Oftenthewrongword() {
				this.isNum = false;
				this.reswrongword = "";
				this.isshow2 = true;
				let reg = /^[0-9]+$/
				if (reg.test(this.thewrongword)) {
					this.isNum = true
				}
			},
			//加精华
			Addtheessence() {
				this.isshow3 = true;
				this.biaoqianlist = []
				this.$u.post('/addtodigest/findAllYi', {}).then(data => {
					this.biaoqianlist = data
					this.biaoqianlist.unshift({
						name: "逼单话术",
						id: 0
					})
				})
			},
			// 取消加精
			Cancelout2() {
				this.isshow3 = false;
				this.dialogList.forEach(res => {
					res.message.forEach(asd => {
						asd.isshow = false;
					})
				})
			},
			// 确认加精
			Confirmtheexit2() {
				if (this.biaoqianid) {
					this.biaoqianid = this.biaoqianid
				} else {
					this.biaoqianid = 0
				}
				this.isshow3 = false;
				this.dialogList.forEach(res => {
					res.message.forEach(asd => {
						asd.isshow = false;
					})
				})
				let objdata = {
					"carId": this.customerId, //客户id
					"startTime": this.changanitem.bg, //开始时间
					"startFile": this.duihuawenjianid, //对话所在录音文件id
					"endTime": this.changanitem.ed, //结束时间
					"marketingId": this.biaoqianid, //对应一级父id
					"jjTransfer": this.changanitem.onebest, //选中对话
					"status": 1
				}
				this.$u.post(config.service.addATD, objdata).then(data => {
					uni.showToast({
						title: '加精成功',
						duration: 2000
					});
				}).catch(e => {
					uni.showToast({
						title: e.message,
						icon: 'none',
						duration: 2000
					});
				})
			},
			//长按对话
			changanxiaoguo(item, index, i) {
				this.messagelisy = [];
				this.changanitem = {};
				this.duihuawenjianid = "";
				this.dialogList.forEach(res => {
					res.message.forEach(asd => {
						asd.isshow = false;
					})
				})
				this.changanitem = item;
				this.duihuawenjianid = this.luyinList[this.csdFileindex].id;
				this.dialogList[i].message[index].isshow = !this.dialogList[i].message[index].isshow;
				this.textItself = item.onebest;
				let onebest = item.onebest;
				this.thewrongword = onebest.replace(/<.*?>/ig, "");
				this.thewrongword = item.onebest;
				this.messagelisy = this.dialogList[i].message
				this.argtextindex1 = i;
				this.argtextindex2 = index;
			},

			eqLogClick() {
				uni.navigateTo({
					url: `./equipmentLog?id=${this.customerId}`
				})
			},

			//回到顶部
			gotoTop() {
				this.scrollId = null;
				this.$nextTick(() => {
					this.scrollId = "top";
				})
			},
			//切换tab
			changeTab(type) {
				if (type == 0) {
					this.tab = 0
				} else {
					this.tab = 1;
					this.getRatelist();
				}
			},
			//录音列表显示隐藏
			showFile() {
				this.isshowFile = !this.isshowFile;
			},

			//评分上下显隐
			changeshow(item, type) {
				if (type == 1) {
					item.show = true
				} else {
					item.show = false
				}
			},
			// 获取评分
			getRatelist() {
				if (this.ratelist.length == 0) {
					this.$u.get("/customer/findzkMByCusId", {
						cusId: this.customerId
					}).then(res => {
						if (res.length) {
							let level1 = []
							let level2rate = 0
							res.forEach(item => {
								if (item.pid == 0) {
									level1.push({
										id: item.marketingId,
										rate: item.fraction,
										name: item.name,
										sort: item.sort,
										show: false,
										ratepercent: 0,
										children: []
									})
								} else {
									if (item.selected == 0) {
										level2rate += item.fraction
									}
								}
							})
							this.totalRate = level2rate
							res.forEach(subitem => {
								let subitempid = subitem.pid
								level1.forEach(item => {
									if (subitempid == item.id) {
										if (subitem.selected == 0) {
											item.ratepercent += subitem.fraction
										}
										item.children.push({
											id: subitem.id,
											rate: subitem.fraction,
											selected: subitem.selected,
											name: subitem.name
										})
									}
								})
							})
							console.log(level1)
							level1[0].show = true;
							this.ratelist = level1
						}
						setTimeout(function() {
							uni.hideLoading();
						}, 1000);
					})
				}


			},

			// 获取转义后的对话结果
			getCorpusAnalysis(info) {
				this.dialogList = [];
				let obj = {
					corpusId: this.luyinList[this.csdFileindex].id,
					customerId: this.customerId
				}
				this.$u.get(config.service.getCorpusAnalysis, obj).then(data => {
					try {
						const jsonInfo = JSON.parse(data.audioContent);
						// console.log(jsonInfo)
						if (this.luyinList[this.csdFileindex].recordDuration > 360) {
							//拿到总条数
							var stusnum = jsonInfo.length;
							this.dialogList.push({
								message: jsonInfo.splice(0, 80),
								backindex: this.csdFileindex
							});

							var auth_timetimer = setInterval(() => {
								stusnum -= 100;
								// console.log("还剩下" + stusnum)
								if (stusnum <= 0) {
									clearInterval(auth_timetimer);
								} else {
									var newlistwang = [];
									newlistwang = jsonInfo.splice(0, 100);
									newlistwang.forEach(item => {
										this.dialogList[0].message.push(item)
									})
								}
							}, 1000);
						} else {
							this.dialogList.push({
								message: jsonInfo,
								backindex: this.csdFileindex
							});
						}
						this.dialogList.forEach((asd, idx) => {
							asd.message.forEach((qwe, inde) => {
								qwe.isshow = false;
							})
						})
					} catch (e) {
						if (data.whetherFinishName == '转写中') {
							uni.showModal({
								title: '提示',
								content: '录音正在转写中，请稍后重试！',
								showCancel: false
							});
						}
					}
				}).catch(e => {
					// if (e.da)
					uni.showModal({
						title: '提示',
						content: '请求数据失败，请重新尝试',
						showCancel: false
					});
				})
			},
			getTime(time) {
				return util.formatSecond(time)
			},

			//音频前进回退
			sliderChangeComplate(currentTime) {
				// 暂时没有处理
				// this.$refs.zyAudio.seek(e.detail.value);
				// this.$refs.zyAudio.play();
			},
			//长按点击播放
			clickbofang(dialog, item) {
				this.dialogList.forEach(res => {
					res.message.forEach(asd => {
						asd.isshow = false;
					})
				})
				this.$forceUpdate()
				if (dialog == this.csdFileindex) {
					let time = item.bg / 1000
					this.stepPlay(time);
					return
				} else {
					let time = item.bg / 1000
					this.csdFileindex = dialog;
					this.recordPath = this.luyinList[dialog].recordPath;
					this.date = this.luyinList[dialog].receptionTime;
					this.getCorpusAnalysis()
					this.stepPlay(time);
				}
			},
			// 文件切换播放
			filechange(item, i) {
				this.num = i; //下拉起始位置
				this.Bnum = i;
				this.csdFileindex = i;
				this.recordPath = item.recordPath;
				this.date = item.receptionTime;
				this.isshowFile = false;
				setTimeout(() => {
					this.$zaudio.operate(i)
				}, 50)
				this.getCorpusAnalysis()
			},
			// 自动播放下一个文件
			qeihuanwenjian() {
				// this.$zaudio.paused()
				let index = this.csdFileindex + 1;
				if (index < this.luyinList.length) {
					this.csdFileindex = index;
					this.getCorpusAnalysis()
					let item = this.luyinList[this.csdFileindex];
					let i = this.csdFileindex;
					this.filechange(item, i)
				}
			},
			formatTime(num) {
				//格式化时间格式
				num = num.toFixed(0);
				let second = num % 60;
				if (second < 10) second = '0' + second;
				let min = Math.floor(num / 60);
				if (min < 10) min = '0' + min;
				return min + ":" + second;
			},
			changeEditing() {
				this.dialogList.forEach(res => {
					res.message.forEach(asd => {
						asd.isshow = false;
					})
				})
			},
			
			// 迅速切换音频源并切换回来
			checkPlaybackRate() {
				this.stepPosition = this.nowPlaying
				// 
				let data = [{
					src: 'https://static.quhouse.com/record/prop/2022-12-13/1670905992910-00066.mp3',
					title: '录音音频',
					singer: '',
					coverImgUrl: ''
				}]
				this.$zaudio.setAudio(data)
				//渲染第一首音频
				this.$zaudio.setRender(0)
				if (!this.refresh) {
					setTimeout(() => {
						this.$zaudio.operate()
					}, 150)
				}
				setTimeout(() => {
					this.zyAudio()
				}, 500)
			},
			
			//录音实例
			zyAudio() {
				let data = this.luyinList.map((item, index) => {
					return {
						src: item.recordPath,
						title: `录音文件${index + 1}`,
						singer: '',
						coverImgUrl: ''
					}
				})
				this.$zaudio.setAudio(data)
				//渲染第一首音频
				this.$zaudio.setRender(0)

				setTimeout(() => {
					this.$zaudio.operate()
				}, 150)
				
				if (this.stepPosition != 0) {
					setTimeout(() => {
						this.stepPlay(this.stepPosition)
					}, 1500)
				}
				this.$forceUpdate()
			},

			// 跳转指定位置播放
			stepPlay(t) {
				this.$zaudio.seek(t)
				if (this.$zaudio.paused) {
					this.$zaudio.operate()
				}
			},
		}
	}
</script>
<style lang="scss" scoped>
	.ffectivetext {
		width: 85%;
		margin: 10rpx auto;
		height: 100rpx;
		padding: 20rpx;
		border: 1rpx solid #E4F0FF;
	}

	.biaoqiantom {
		background-color: #008EF2;
		color: #FFFFFF;
		border: none;
	}

	// 表单
	.tian-view {
		width: 570rpx;
		background-color: #FFFFFF;
		border-bottom: 1px solid #ededee;
		display: flex;
		min-height: 96rpx;

		.tian-view-t1 {
			width: 20rpx;
			font-size: 34rpx;
			height: 34rpx;
			line-height: 110rpx;
			letter-spacing: 0px;
			color: red;
		}

		.tian-view-t2 {
			width: 30%;
			min-height: 96rpx;
			line-height: 96rpx;
			font-size: 34rpx;
			color: #333;
		}

		.tian-view-t3 {
			width: 61%;
			padding-top: 31rpx;
			padding-bottom: 31rpx;
			display: flex;

			.tian-input {
				width: 98%;
				height: 30rpx;
				font-size: 34rpx;
				border: none;
			}
		}
	}

	.zhezhoa {
		position: fixed;
		top: 0;
		left: 0;
		z-index: 999;
		width: 100%;
		height: 100vh;
		opacity: 0.5;
		background-color: #666666;
	}

	.bounced {
		width: 570rpx;
		background: #FFFFFF;
		z-index: 1000;
		border-radius: 10rpx;
		position: fixed;
		left: 50%;
		top: 50%;
		transform: translate(-50%, -50%);

		/* 50%为自身尺寸的一半 */
		.jiajinghuatit {
			width: 100%;
			height: 68rpx;
			font-size: 30rpx;
			text-align: center;
			line-height: 68rpx;
		}

		.jiajinghuaview {
			padding: 18rpx 18rpx 18rpx 18rpx;
			display: flex;
			flex-wrap: wrap;
			height: 50vh;
			overflow-y: scroll;

			.jiajinghuaview1 {
				padding: 8rpx 8rpx 8rpx 8rpx;
				font-size: 26rpx;
				border-radius: 12rpx;
				border: 1px solid #979797;
				margin-left: 8rpx;
			}

			.jighuaview2 {
				padding: 8rpx 18rpx 8rpx 18rpx;
				font-size: 26rpx;
				border-radius: 12rpx;
				border: 1px solid #979797;
				margin-left: 20rpx;
				margin-top: 10rpx;
				display: flex;

				.view1-text {
					text-align: center;
				}

				.view1-img {
					width: 50rpx;
				}
			}
		}

		.bounced3 {
			height: 100rpx;
			width: 100%;
			margin-top: 40rpx;
			border-top: 1px solid #dddddd;
			display: flex;
		}

		.bounced3-1 {
			width: 50%;
			height: 100%;
			text-align: center;
			line-height: 100rpx;
			border-right: 1px solid #dddddd;
			font-size: 36rpx;
			color: #999999;
		}

		.bounced3-2 {
			width: 50%;
			height: 100%;
			text-align: center;
			line-height: 100rpx;
			font-size: 36rpx;
			color: #108ee9;
		}
	}

	.translation {
		padding-left: 30rpx;
		padding-right: 30rpx;
		background: #FFFFFF;
		display: flex;
		flex-direction: column;
		height: 100vh;
	}

	.translation .top {
		margin: 0 -30rpx;
		padding: 0 30rpx;
		background: #ffffff;
		border-bottom: 1rpx solid #F2F2F2;
		padding-bottom: 10rpx;
	}

	.translation .top .title {
		display: flex;
		justify-content: space-between;

		.hash {
			color: rgba(21, 144, 233, 1);
			font-size: 24rpx;
		}
	}

	.call_record_time {
		height: 42rpx;
		font-size: 30rpx;
		font-family: PingFangSC-Medium, PingFang SC;
		font-weight: 500;
		color: #303030;
		line-height: 42rpx;
		margin-bottom: 20rpx;
	}

	.call_record_time_one {
		font-family: PingFangSC-Regular, PingFang SC;
		font-weight: 400;
		color: #303030;
		height: 48rpx;
		font-size: 28rpx;
		line-height: 48rpx;
		display: flex;
		justify-content: space-between;
		align-items: center;
		position: relative;

		.menu {
			width: 36rpx;
			height: 36rpx;
		}

		.audoioyouxiao {
			color: #333333;
			font-size: 28rpx;
			line-height: 48rpx;
			font-family: PingFangSC-Regular, PingFang SC;
			font-weight: 400;
			position: absolute;
			top: 0rpx;
			right: 126rpx;
		}

		.diangweitupian {
			width: 46rpx;
			height: 46rpx;
			position: absolute;
			top: 0rpx;
			right: 75rpx;
		}

		.file-change {
			position: absolute;
			top: 50rpx;
			right: 0rpx;
			width: 184rpx;
			background: #FFFFFF;
			box-shadow: 0rpx 0rpx 6rpx 2rpx rgba(230, 230, 230, 0.5);
			border-radius: 4rpx;
			z-index: 99;
			height: auto;
			max-height: 600rpx;
			overflow: auto;
		}

		.file-item {
			width: 184rpx;
			height: 60rpx;
			line-height: 60rpx;
			text-align: center;
			font-size: 30rpx;
			font-weight: 400;
			color: #333333;
			border-bottom: 1rpx solid #E2E2E2;
		}

		.file-item:last-child {
			border: 0
		}

		.fileactive {
			color: #008EF2
		}
	}

	.audio-container {
		width: 100%;
		display: flex;
		justify-content: space-between;
		align-items: center;

		.audio-head {
			width: 60rpx;
			height: 60rpx;
			flex-shrink: 0;
		}

		.audio-head .image {
			width: 100%;
			height: 100%;
		}

		.audio-slider {
			width: 96%;
			position: relative;
			padding: 2px 0rpx 0px 20px;
			display: flex;
			justify-content: space-between;
			align-items: center;
		}

		.audio-slider .slider {
			width: 100%;
			padding: 0px 15rpx;
			box-sizing: border-box;
		}

		.audio-time {
			width: 110rpx;
			text-align: right;
			font-size: 24rpx;
			line-height: 28rpx;
			color: #70798D;
			display: flex;
			justify-content: space-between;
		}

		.audio-play {
			width: 40rpx;
			height: 40rpx;
			flex-shrink: 0;
		}

		.audio-play .image {
			width: 100%;
			height: 100%;
		}
	}

	.scroll-Y {
		font-size: 36rpx;
		color: #999999;
		background: #FFFFFF;
		margin-top: 30rpx;
		flex: 1;
		overflow-y: scroll;
		width: 100%;
	}

	.scroll-Y .text {
		position: relative;
		line-height: 42rpx;
		display: flex;
		margin-top: 30rpx;
		font-size: 30rpx;
		color: #505050;
	}

	.scroll-Y .text[data-speaker="2"],
	.scroll-Y .text[data-speaker="4"],
	.scroll-Y .text[data-speaker="6"] {
		flex-direction: row-reverse;
		text-align: right;

		.content {
			flex-direction: row-reverse;

			.contentdesc {
				margin-left: 0;
				margin-right: 30rpx;
			}

			.play {
				margin-right: 20rpx;
				width: 50rpx;
				height: 50rpx;
			}
		}
	}

	.scroll-Y .text .avatar {
		text {
			display: block;
			width: 72rpx;
			height: 72rpx;
			line-height: 72rpx;
			text-align: center;
			background: #FFFFFF;
			border-radius: 8rpx;
			font-size: 30rpx;
			font-family: PingFangSC-Medium, PingFang SC;
			font-weight: 500;
			box-sizing: border-box;
		}
	}

	.scroll-Y .text .content {
		display: flex;
		align-items: center;

		.contentdesc {
			border-radius: 12rpx;
			max-width: 460rpx;
			margin-left: 30rpx;
			text-align: left;
			line-height: 42rpx;
			padding: 15rpx 20rpx;
			background: #f8f8f8;
			color: #505050;
		}

		.play {
			width: 50rpx;
			height: 50rpx;
			margin-left: 20rpx;
		}

		.tankuangcss {
			position: absolute;
			top: -140rpx;
			left: 50%;
			transform: translateX(-50%);
			z-index: 1000;
			min-width: 150rpx;
			height: 140rpx;
			display: flex;
			background: rgba(48, 48, 48, 0.8);
			border-radius: 15rpx;

			.play {
				width: 50rpx;
				height: 50rpx;
				margin-left: 20rpx;
			}

			.tankuangcss-items {
				width: 150rpx;
				display: flex;
				flex-direction: column;
				justify-content: center;
				align-items: center;

				image {
					width: 36rpx;
					height: 36rpx;
				}

				text {
					margin: 12rpx 0 0 0;
					font-size: 24rpx;
					color: #fff;
				}
			}
		}
	}

	.scroll-Y .text.active .content {
		color: #2671E2 !important;
		// position: relative;
	}

	.scroll-Y .text.active[data-speaker="2"] .content,
	.scroll-Y .text.active[data-speaker="4"] .content,
	.scroll-Y .text.active[data-speaker="6"] .content {
		color: #2671E2 !important;
		// position: relative;
	}

	.tab-box {
		width: 100%;
		display: flex;
		justify-content: center;
		align-items: center;

		.yinpinshibie {
			width: 156rpx;
			height: 50rpx;
			font-size: 36rpx;
			font-weight: 400;
			color: #333333;
			text-align: center;
			line-height: 50rpx;
			letter-spacing: 2rpx;
			margin-right: 188rpx;

			&.active {
				position: relative;

				&::after {
					position: absolute;
					content: '';
					width: 119rpx;
					height: 8rpx;
					background: #008EF2;
					border-radius: 4rpx;
					top: 50rpx;
					right: 0;
					left: 0;
					margin: 0 auto;
				}
			}
		}

		.rate {
			width: 156rpx;
			height: 50rpx;
			font-size: 36rpx;
			font-weight: 400;
			color: #333333;
			line-height: 50rpx;
			letter-spacing: 2rpx;
			text-align: center;

			&.active {
				position: relative;

				&::after {
					position: absolute;
					content: '';
					width: 119rpx;
					height: 8rpx;
					background: #008EF2;
					border-radius: 4rpx;
					top: 50rpx;
					right: 0;
					left: 0;
					margin: 0 auto;
				}
			}
		}
	}

	.eqLog {
		width: 115upx;
		height: 115upx;
		background: rgba(211, 235, 253, 1);
		box-shadow: 0 0 10rpx 7rpx #f1f1f1;
		;
		border-radius: 50%;
		position: fixed;
		bottom: 300upx;
		right: 8upx;
		display: flex;
		justify-content: center;
		align-items: center;
		color: #008EF2;
	}

	.backTop {
		width: 112rpx;
		height: 112rpx;
		position: fixed;
		bottom: 110rpx;
		right: 40rpx;

		image {
			width: 112rpx;
			height: 112rpx;
		}
	}

	// 评分
	.rate-box {
		padding: 10rpx 20rpx;

		.date {
			width: 300rpx;
			height: 33rpx;
			font-size: 24rpx;
			font-weight: 400;
			color: #333333;
			line-height: 33rpx;
			letter-spacing: 1rpx;
			margin-bottom: 8rpx;
		}

		.title {
			width: 100%;
			height: 42rpx;
			font-size: 30rpx;
			font-weight: 500;
			color: #333333;
			line-height: 42rpx;
			letter-spacing: 2rpx;
			margin-bottom: 20rpx;
		}

		.level1 {
			display: flex;
			align-items: center;

			.level-name {
				width: 104rpx;
				height: 33rpx;
				font-size: 24rpx;
				font-weight: 500;
				color: #333333;
				line-height: 33rpx;
				letter-spacing: 1rpx;
				margin-right: 10rpx;
			}

			.level-progress {
				flex: 1;
				border-radius: 11rpx;
				height: 21rpx;
				background-color: #BEE4FF;
				position: relative;

				.color {
					width: 0;
					position: absolute;
					top: 0;
					left: 0;
					height: 21rpx;
					border-radius: 11rpx 0 0 11rpx;
					background-color: #008EF2;
				}
			}

			.level-rate {
				width: 65rpx;
				height: 33rpx;
				font-size: 24rpx;
				font-weight: 500;
				color: #333333;
				line-height: 33rpx;
				letter-spacing: 1rpx;
				margin: 0 20rpx 0 15rpx;
			}

			.arrow {
				width: 37rpx;
				height: 21rpx;
				padding: 5rpx 20rpx;
			}

			.rotatearrow {
				transform: rotate(270deg);
			}
		}

		.level1-subbox {
			display: flex;
			margin-top: 20rpx;
			flex-wrap: wrap;

			.sub-name {
				width: 50%;
				display: flex;
				margin-bottom: 18rpx;

				.subitem-name {
					width: 104rpx;
					height: 33rpx;
					font-size: 24rpx;
					font-weight: 400;
					color: #999999;
					line-height: 33rpx;
					letter-spacing: 1rpx;
					margin-right: 12rpx;
				}

				.checkimg {
					width: 27rpx;
					height: 27rpx;
				}
			}
		}
	}

	.dialog-block {
		margin: 20rpx 0;
		border-bottom: 1rpx solid #ccc;
		padding-bottom: 30rpx;

		.fileName {
			text-align: center;
			margin: 10rpx auto;
			width: 115rpx;
			height: 42rpx;
			line-height: 42rpx;
			background: #EFEFEF;
			border-radius: 4rpx;
			font-size: 20rpx;
			font-weight: 400;
			color: #333333;
		}
	}

	/deep/ .u-model-title {
		padding: 34rpx 0 16rpx !important;
	}
	
</style>
